"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
/**
 * the resolved assets path is the path ot the assets folder in the running environment
 */
exports.resolveAssetsPath = (buildPath, serverName, assetsPath) => {
    const path = require('path');
    const resolvedPath = path.resolve(buildPath, serverName, assetsPath);
    return !resolvedPath.endsWith("/") ? resolvedPath + "/" : resolvedPath;
};
exports.getStaticBucketName = (accountId, stackName, assetsPath, stage) => {
    return `infrcomp-${accountId}-${stackName}-${assetsPath !== undefined ? assetsPath + "-" : ""}${stage}`;
};
exports.getBasename = () => {
    // first check whether we are a client
    if (typeof window != 'undefined' && window.__BASENAME__) {
        return window.__BASENAME__;
    }
    return process.env.STAGE_PATH && process.env.STAGE_PATH !== "undefined" ? "/" + process.env.STAGE_PATH : "/";
};
//# sourceMappingURL=iso-libs.js.map