"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
/**
 * Export the Infrastructure Types that we support
 * Each type may have certain characteristics within infrastructure-components
 */
exports.default = {
    /**
     * The configuration is the top-level component of any infrastructure-components configuration
     * configurations define the Plugins supported in the configuration
     */
    INFRASTRUCTURE_TYPE_CONFIGURATION: "INFRASTRUCTURE_TYPE_CONFIGURATION",
    /**
     * a client produces a webpack configuration, e.g. a webapp or an API endpoint
     */
    INFRASTRUCTURE_TYPE_CLIENT: "INFRASTRUCTURE_TYPE_CLIENT",
    /**
     * A component has no special characteristics
     * what they do is completely up to their plugins
     */
    INFRASTRUCTURE_TYPE_COMPONENT: "INFRASTRUCTURE_TYPE_COMPONENT"
};
//# sourceMappingURL=index.js.map